'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Common = function () {
  function Common(statKey, groupKey, cb) {
    _classCallCheck(this, Common);

    this.statKey = statKey;
    this.groupKey = groupKey;
    this.cb = cb;
  }

  _createClass(Common, [{
    key: 'group',
    value: function group(groupKey) {
      return new Common(this.statKey, groupKey, this.cb);
    }
  }, {
    key: 'setTime',
    value: function setTime(datetime) {
      this.datetime = datetime;
      return this;
    }
  }, {
    key: 'inc',
    value: async function inc(v) {
      return this._action('inc', v);
    }
  }, {
    key: 'dec',
    value: async function dec(v) {
      return this._action('dec', v);
    }
  }, {
    key: 'set',
    value: async function set(v) {
      return this._action('set', v);
    }
  }, {
    key: '_action',
    value: async function _action(action, value) {
      var json = {
        statKey: this.statKey,
        action: action,
        value: value
      };
      if (this.datetime) {
        json.datetime = this.datetime;
      }
      if (this.groupKey) {
        json.groupKey = this.groupKey;
      }
      return this.cb(json);
    }
  }]);

  return Common;
}();

var Stat = function (_Common) {
  _inherits(Stat, _Common);

  function Stat(key, cb) {
    _classCallCheck(this, Stat);

    var _this = _possibleConstructorReturn(this, (Stat.__proto__ || Object.getPrototypeOf(Stat)).call(this, key, null, cb));

    console.log(_this.group);
    return _this;
  }

  return Stat;
}(Common);

module.exports = Stat;